package com.netifera.platform.host.terminal.ui;

import org.eclipse.tm.internal.terminal.provisional.api.ITerminalConnector;
import org.eclipse.tm.internal.terminal.provisional.api.TerminalConnectorExtension;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.internal.UIPlugin;

import com.netifera.platform.api.tools.IToolConfiguration;
import com.netifera.platform.host.internal.terminal.ui.Activator;
import com.netifera.platform.host.internal.terminal.ui.ReadOnlySettingsStore;
import com.netifera.platform.host.terminal.ui.view.TerminalView;
import com.netifera.platform.ui.actions.SpaceAction;

public class OpenTerminalAction extends SpaceAction {

	public OpenTerminalAction(String name) {
		super(name);
		setImageDescriptor(Activator.getInstance().getImageCache().getDescriptor("icons/terminal_view.png"));
		// TODO Auto-generated constructor stub
	}

	@Override
	public void run() {
		IToolConfiguration config = getConfiguration();

		ITerminalConnector conn = TerminalConnectorExtension
				.makeTerminalConnector((String)config.get("connector"));
		if (conn == null) {
			return;
		}
		
		// force instantiating the real connector
		conn.makeSettingsPage();
		conn.load(new ReadOnlySettingsStore(new String[] { "Host",
				(String)config.get("host"), "NetworkPort", config.get("port").toString() }));
		
/*		ITerminalViewControl ctlTerminal = TerminalViewControlFactory
				.makeControl(this, wndParent, conn);

		ctlTerminal.setConnector(conn);

		ctlTerminal.connectTerminal();
*/
		try {
			IViewPart newTerminalView = UIPlugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getActivePage().showView(
					"org.eclipse.tm.terminal.view.TerminalView",//$NON-NLS-1$
					"SecondaryTerminal" + System.currentTimeMillis(), //$NON-NLS-1$
					IWorkbenchPage.VIEW_ACTIVATE);
			TerminalView terminal = (TerminalView)newTerminalView;
			
			Boolean commandInputField = (Boolean)config.get("commandInputField");
			if (commandInputField != null) terminal.setCommandInputField(commandInputField);

			terminal.setConnector(conn);
			terminal.onTerminalConnect();
//			conn.connect(terminal);
		} catch (PartInitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
