package com.netifera.platform.internal.model;

import com.netifera.platform.api.model.IEntity;
import com.netifera.platform.api.model.IShadowEntity;
import com.netifera.platform.api.model.ITreeBuilderProvider;
import com.netifera.platform.model.FolderEntity;
import com.netifera.platform.model.ProbeEntity;
import com.netifera.platform.model.TreeStructureContext;

public class CoreTreeBuilderProvider implements ITreeBuilderProvider {

	public boolean isHandled(final IEntity entity) {
		return (entity instanceof ProbeEntity)
			|| (entity instanceof FolderEntity);
	}

	public IShadowEntity createRoot(final IEntity entity) {
		if(entity instanceof ProbeEntity)
			return TreeStructureContext.createRoot(entity);
		return null;
	}

	public IEntity[] getParents(IEntity entity) {
		return new IEntity[0];
	}

	public boolean isRealmRoot(IEntity entity) {
		return (entity instanceof FolderEntity) || ((entity instanceof ProbeEntity) && !((ProbeEntity)entity).isLocal());
	}
}
