package com.netifera.platform.net.internal.daemon.sniffing.model;

import com.netifera.platform.api.model.IEntity;
import com.netifera.platform.api.model.IShadowEntity;
import com.netifera.platform.api.model.ITreeBuilderProvider;
import com.netifera.platform.model.TreeStructureContext;
import com.netifera.platform.net.daemon.sniffing.model.CaptureFileEntity;
import com.netifera.platform.net.daemon.sniffing.model.NetworkInterfaceEntity;
import com.netifera.platform.net.daemon.sniffing.model.SniffingSessionEntity;

public class TreeBuilderProvider implements ITreeBuilderProvider {

	public IShadowEntity createRoot(IEntity entity) {
		if(isHandled(entity)) {
			return TreeStructureContext.createRoot(entity);
		}
		return null;
	}

	public boolean isHandled(IEntity entity) {
		return (entity instanceof SniffingSessionEntity) ||
			(entity instanceof CaptureFileEntity) ||
			(entity instanceof NetworkInterfaceEntity);
	}

	public IEntity[] getParents(IEntity entity) {
		return new IEntity[0];
	}

	public boolean isRealmRoot(IEntity entity) {
		return isHandled(entity);
	}
}
