package com.netifera.platform.net.internal.sniffing.managers;

import com.netifera.platform.net.packets.IPacketHeader;
import com.netifera.platform.net.sniffing.IPacketContext;
import com.netifera.platform.net.sniffing.IPacketSniffer;
import com.netifera.platform.net.sniffing.util.AbstractPacketManager;
import com.netifera.platform.net.sniffing.util.CaptureFileInterface;
import com.netifera.platform.net.sniffing.util.ISniffingEngineEx;

public class CaptureFileManager extends AbstractPacketManager<IPacketHeader> {

	public CaptureFileManager(ISniffingEngineEx engine,
			CaptureFileInterface iface) {
		super(engine, iface);
		
		iface.setSniffer(new IPacketSniffer<IPacketHeader>() {

			public void handlePacket(IPacketHeader packet, IPacketContext ctx) {
				deliverPacket(packet, ctx.getCaptureHeader());				
			}
		});
	}

	@Override
	protected boolean start() {
		return true;
	}

	@Override
	protected void stop() {		
	}

}
