package com.netifera.platform.ui.spaces.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.PartInitException;

import com.netifera.platform.api.model.ISpace;
import com.netifera.platform.api.model.IWorkspace;
import com.netifera.platform.api.probe.IProbe;
import com.netifera.platform.ui.internal.spaces.Activator;
import com.netifera.platform.ui.probe.views.ProbeListView;
import com.netifera.platform.ui.spaces.SpaceEditorInput;

public class OpenSpaceDelegate implements IViewActionDelegate {
	private ProbeListView view;
	
	public void init(IViewPart view) {
		this.view = (ProbeListView) view;
	}

	public void run(IAction action) {
		IProbe probe = view.getSelectedProbe();
		if (probe != null)
			openSpaceForProbe(probe);
	}
	
	private void openSpaceForProbe(IProbe probe) {
		final ISpace space = openSpace(probe);
		openEditor(space);
	}
	
	private ISpace openSpace(IProbe probe) {
		final IWorkspace workspace = Activator.getDefault().getModel().getCurrentWorkspace();
		final ISpace space = workspace.createSpace(probe.getEntity(), probe);
		space.open();
		return space;
	}
	
	private void openEditor(ISpace space) {
		final IEditorInput input = new SpaceEditorInput(space);
		try {
			view.getViewSite().getPage().openEditor(input, SpaceEditorInput.ID);
		} catch(PartInitException e) {
			// XXX
			e.printStackTrace();
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		System.out.println("selection changed "+selection);
/*		final Object element = ((IStructuredSelection)selection).getFirstElement();
		if(element instanceof IProbe)
			probe = (IProbe) element;
		else
			probe = null;
*/	}
}
